// *********************************************************************
//  Created with bc9Basic - BASIC To C/C++ Translator (V) 9.2.5.9 (2017/01/27)
//       The bc9Basic translator (bc9.exe) was compiled with
//                           g++ (tdm64-1) 5.1.0
// ----------------------------------------------------------------------
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with the
//           Microsoft (R) C/C++ Optimizing Compiler
//                           On MS Windows
//                    Using TCLib by Fred Harris
// *********************************************************************
#ifndef UNICODE
#define UNICODE
#endif
#ifndef _UNICODE
#define _UNICODE
#endif
#define _X(y) y
#include <windows.h>
#define   x64
#include "TCLib\stdio.h"
#include "TCLib\string.h"
#include "TCLib\stdlib.h"
#include "TCLib\memory.h"
#include "TCLib\malloc.h"
#include "TCLib\math.h"
#include "TCLib\tchar.h"
#include "TCLib\Strings.cpp"
typedef String fstring;
FILE* stdin;
FILE* stdout;
FILE* stderr;
//<---UNICODE AWARE
#define SFMT (const char*)"%s\r\n"
//>---UNICODE AWARE

// NO HEADERS START
#ifndef _WINDOWS_
//<---UNICODE AWARE
typedef _TCHAR *PCHAR, *LPCH, *PCH, *NPSTR, *LPSTR, *PSTR;
typedef unsigned long DWORD, *PDWORD, *LPDWORD;
typedef unsigned int UINT;
//>---UNICODE AWARE
#endif
// NO HEADERS END
// ***************************************************
// Compiler Defines
// ***************************************************
#ifndef __cplusplus
#error A C++ compiler is required
#endif
// $HEADER BEGIN
#include "aedynarray.h"
#include <commctrl.h>
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"Winspool.lib")
struct AddressType;
typedef AeDynArray<AddressType> AddressTypeArray;
// $HEADER END


// *************************************************
//        User's GLOBAL ENUM blocks
// *************************************************

// *************************************************
//            System Defined Constants
// *************************************************

typedef const _TCHAR* ccptr;
#define CCPTR const _TCHAR*
#define cfree free
//<---UNICODE AWARE
typedef char _char;
#define _strlen strlen
//>---UNICODE AWARE
#define EQU ==
#define NOT_USED(x) if(x);
#define CTLHNDL(id) GetDlgItem(hWnd,id)
#define cSizeOfDefaultString 2048

// *************************************************
//            User Defined Constants
// *************************************************

#define IDD_DLG1 1000
#define IDC_STC20 1001
#define IDC_INDEX 1002
#define IDC_STC21 1003
#define IDC_COMPANY 1004
#define IDC_STC22 1005
#define IDC_LASTNAME 1006
#define IDC_STC23 1007
#define IDC_FIRSTNAME 1008
#define IDC_STC24 1009
#define IDC_ADDRESS1 1010
#define IDC_ADDRESS2 1011
#define IDC_ADDRESS3 1012
#define IDC_STC25 1013
#define IDC_CITYNAME 1014
#define IDC_STC26 1015
#define IDC_STATENAME 1016
#define IDC_STC27 1017
#define IDC_ZIPCODE 1018
#define IDC_STC28 1019
#define IDC_COUNTRY 1020
#define IDC_STC29 1021
#define IDC_PHONE 1022
#define IDC_STC30 1023
#define IDC_FAX 1024
#define IDC_STC31 1025
#define IDC_EMAIL 1026
#define IDC_STC32 1027
#define IDC_URL 1028
#define IDC_STC33 1039
#define IDC_COMMENTS 1029
#define IDC_PRIOR 1030
#define IDC_NEXT 1031
#define IDC_FIND 1032
#define IDC_ADD 1033
#define IDC_UPDATE 1034
#define IDC_DELETE 1035
#define IDC_PRINT 1036
#define IDC_SBR1 1037
#define IDC_LSV1 1038
#define IDR_MENU1 10000
#define IDM_SAVE 10001
#define IDM_HELP2 10004
#define IDM_ABOUT 10005
#define IDD_DLG2 1100
#define IDC_DLG2_STC1 1101
#define IDC_DLG2_EDT1 1102
#define IDC_DLG2_BTN1 1103
#define IDC_DLG2_BTN2 1104
#define C_Company IDC_STC21
#define C_LastName IDC_STC22
#define C_FirstName IDC_STC23
#define C_Address IDC_STC24
#define C_CityName IDC_STC25
#define C_StateName IDC_STC26
#define C_ZipCode IDC_STC27
#define C_Phone IDC_STC29
#define C_Fax IDC_STC30
#define C_Email IDC_STC31
#define C_Url IDC_STC32
#define C_Comments IDC_STC33

// *************************************************
//               Standard Prototypes
// *************************************************

DWORD   FGet(HANDLE, LPVOID, int);
BOOL    FPut(HANDLE, LPVOID, int);
int     FindInType(const _TCHAR *, const _TCHAR *, int, int, int, int = 0, int* = 0);
// *************************************************
//          User Defined Types, Unions and Classes
// *************************************************


struct AddressType
{
    _TCHAR     Company[64] = {0};
    _TCHAR     LastName[32] = {0};
    _TCHAR     FirstName[32] = {0};
    _TCHAR     Address1[64] = {0};
    _TCHAR     Address2[64] = {0};
    _TCHAR     Address3[64] = {0};
    _TCHAR     CityName[24] = {0};
    _TCHAR     StateName[4] = {0};
    _TCHAR     ZipCode[12] = {0};
    long     Country = {0};
    _TCHAR     Phone[24] = {0};
    _TCHAR     Fax[24] = {0};
    _TCHAR     Email[64] = {0};
    _TCHAR     Url[64] = {0};
    _TCHAR     Comments[1024] = {0};
};

struct DlgInfoType
{
    AddressTypeArray*  AddArrayPtr = {0};
    int      Index = {0};
    int      IsRecModified = {0};
    int      IsFileModified = {0};
    int      StartRec = {0};
    HINSTANCE  hInst = {0};
    HWND     hParent = {0};
    HWND     hStatus = {0};
    _TCHAR     findtext[1024] = {0};
    int      MaxRecs = {0};
    _TCHAR     dbfile[2048] = {0};
};

// *************************************************
//            User Global Variables
// *************************************************



// *************************************************
//               Standard Macros
// *************************************************


// *************************************************
//               User Prototypes
// *************************************************

int     GetData (HWND);
void    SaveFile (HWND);
int     WINAPI _tWinMain (HINSTANCE, HINSTANCE, LPWSTR, int);
INT_PTR CALLBACK DlgProc (HWND, UINT, WPARAM, LPARAM);
void    AddRecord (HWND);
void    DeleteRecord (HWND);
int     DoSearch (HWND);
int     DoFindDlg (HWND);
INT_PTR CALLBACK FindDlgProc (HWND, UINT, WPARAM, LPARAM);
void    AddCountries (HWND);
void    Udt2Dlg (HWND);
void    Dlg2Udt (HWND);
int     PrintRecord (HWND);
void    SetButtonStatus (HWND);

// *************************************************
//            User Global Initialized Arrays
// *************************************************



// *************************************************
//                 Runtime Functions
// *************************************************

DWORD FGet(HANDLE hFile, LPVOID  Buf, int bites)
{
    DWORD    dwBytesRead = {0};
    BOOL     retval = {0};
    if(Buf == 0 )
    {
        return 0;
    }
    retval = ReadFile( hFile, Buf, bites,  &dwBytesRead, NULL);
    return dwBytesRead;
}
BOOL FPut (HANDLE hFile, LPVOID  Buf, int bites)
{
    BOOL     reval = {0};
    DWORD    dwBytesWritten = {0};
    if(Buf == 0 )
    {
        return 0;
    }
    return WriteFile(hFile, Buf, bites, &dwBytesWritten, NULL);
}
int FindInType(const _TCHAR *Token, const _TCHAR *StOffset, int StSize, int start, int finish, int c, int *idx)
{
    int j;
    _TCHAR *Srch;
    int (*cmp)(const _TCHAR*, const _TCHAR*);
    cmp = ((c == 0 || c == 2) ? _tcscmp : _tcsicmp);
    for(j = start; j <= finish; j++)
    {
        Srch = (_TCHAR*)StOffset + ((idx == 0) ? j*StSize : idx[j] * StSize);
        if(cmp(Srch, Token) == 0)
        {
            return ((c < 2) ? 0 : j);
        }
    }
    return -1;
}



// *************************************************
//       User Subs, Functions and Class Methods
// *************************************************

int GetData (HWND hWnd)
{
    AddressType  Address;
    HANDLE   hFile = {0};
    int      RecSize = {0};
    int      Count = {0};
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArrayPtr;
    fstring  fs;
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    AddArrayPtr = InfoPtr->AddArrayPtr;
    RecSize = sizeof( AddressType);
    fstring  fsFile(InfoPtr->dbfile);
    hFile = CreateFile( fsFile.lpStr(), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
    while(FGet(hFile, &Address, RecSize))
    {
        (*AddArrayPtr ).Add(Address);
        Count++;
    }

    CloseHandle(hFile);
    return Count;
}


void SaveFile (HWND hWnd)
{
    AddressType  Address;
    HANDLE   hFile = {0};
    int      RecSize = {0};
    int      Count = {0};
    int      where = {0};
    int      i = {0};
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArrayPtr;
    fstring  fs;
    SYSTEMTIME  st = {0};
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    AddArrayPtr = InfoPtr->AddArrayPtr;
    RecSize = sizeof( AddressType);
    fstring  fsFile(InfoPtr->dbfile);
    GetSystemTime( &st);
    where = fsFile.InStr(_T("."), false, true);
    where--;
    fs = fsFile.Left( where);
    fs += _T("-");
    fs += (fstring(st.wYear));
    fs += _T("-");
    fs += (fstring(st.wMonth));
    fs += _T("-");
    fs += (fstring(st.wDay));
    fs += _T("-");
    fs += (fstring(st.wHour));
    fs += _T("-");
    fs += (fstring(st.wMinute));
    fs += _T(".bin");
    MoveFile (fsFile.lpStr(), fs.lpStr());
    hFile = CreateFile( fsFile.lpStr(), GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    FPut(hFile, (*AddArrayPtr ).getptr(), sizeof(AddressType)*InfoPtr->MaxRecs);
    CloseHandle(hFile);
}


int WINAPI _tWinMain (HINSTANCE  hInst, HINSTANCE  hPrev, LPWSTR  CmdLine, int CmdShow)
{
    HWND     hDlg = {0};
    MSG      Msg = {0};
    AddressTypeArray  AddArray;
    DlgInfoType  DlgInfo;
    DlgInfo.hInst = hInst;
    _tcscpy(DlgInfo.dbfile, _T("CardFile50.bin"));
    DlgInfo.AddArrayPtr =  &AddArray;
    DlgInfo.Index = 0;
    hDlg = CreateDialogParam( hInst, MAKEINTRESOURCE( IDD_DLG1), 0, DlgProc, ( LPARAM)& DlgInfo);
    while(GetMessage( &Msg, NULL, 0, 0))
    {
        if((IsDialogMessage(hDlg, &Msg) == 0))
        {
            TranslateMessage( &Msg);
            DispatchMessage( &Msg);
        }
    }

    return Msg.wParam;
}


INT_PTR CALLBACK DlgProc (HWND hWnd, UINT Msg, WPARAM  wParam, LPARAM  lParam)
{
    static AddressTypeArray*  AddArrayPtr;
    static DlgInfoType*  InfoPtr;
    switch(Msg)
    {
    case WM_TIMER:
        if(wParam == 1 )
        {
            SetWindowText((*InfoPtr ).hStatus, _T(""));
            KillTimer(hWnd, 1);
        }
        break;
    case WM_INITDIALOG:
        AddCountries(CTLHNDL(IDC_COUNTRY));
        InfoPtr = ( DlgInfoType*) lParam;
        SetProp(hWnd, _T("DLGINFO"), InfoPtr);
        AddArrayPtr = (* InfoPtr).AddArrayPtr;
        (*InfoPtr).Index  = 0;
        InfoPtr->MaxRecs = GetData( hWnd);
        Udt2Dlg(hWnd);
        SetFocus(CTLHNDL(IDC_NEXT));
        (*InfoPtr).hStatus  = CTLHNDL( IDC_SBR1);
        (*InfoPtr).IsRecModified  = FALSE;
        SetButtonStatus(hWnd);
        break;
    case WM_CLOSE:
        if(InfoPtr->IsRecModified )
        {
            if(MessageBox(hWnd, _T("Record data has been changed\nDo you wish to Cancel Add/Update?"), _T("Add/Update Abort Confirm"), MB_ICONQUESTION | MB_YESNO) == IDNO )
            {
                return 1;
                break;
            }
        }
        if(InfoPtr->IsFileModified )
        {
            if(MessageBox(hWnd, _T("Record data has been changed\nDo you wish to Save"), _T("Save Records to File"), MB_ICONQUESTION | MB_YESNO) == IDYES )
            {
                SaveFile(hWnd);
            }
        }
        DestroyWindow(hWnd);
        break;
    case WM_DESTROY:
        RemoveProp(hWnd, _T("DLGINFO"));
        PostQuitMessage(0);
        return 0;
        break;
    case WM_COMMAND:
        if(HIWORD(wParam) == EN_UPDATE || ( LOWORD(wParam) == IDC_COUNTRY && HIWORD(wParam) == CBN_SELCHANGE))
        {
            if(InfoPtr->IsRecModified == FALSE )
            {
                InfoPtr->IsRecModified = TRUE;
                InfoPtr->IsFileModified = TRUE;
                SetButtonStatus(hWnd);
            }
        }
        switch(LOWORD(wParam))
        {
        case IDCANCEL:
            SendMessage(hWnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
            break;
        case IDC_FIND:
            DoFindDlg(hWnd);
            break;
        case IDC_NEXT:
            if((*InfoPtr).IsRecModified)
            {
                if(MessageBox(hWnd, _T("Record data has been changed\nDo you wish to Cancel Add/Update?"), _T("Add/Update Abort Confirm"), MB_ICONQUESTION | MB_YESNO) == IDNO )
                {
                    return 0;
                }
                else
                {
                    (*InfoPtr).IsRecModified  = FALSE;
                    SetButtonStatus(hWnd);
                }
            }
            (*InfoPtr ).Index++;
            if((*InfoPtr).Index > InfoPtr->MaxRecs - 1 )
            {
                (*InfoPtr).Index  = 0;
            }
            Udt2Dlg(hWnd);
            break;
        case IDC_PRIOR:
            if((*InfoPtr).IsRecModified)
            {
                if(MessageBox(hWnd, _T("Record data has been changed\nDo you wish to Cancel Add/Update?"), _T("Add/Update Abort Confirm"), MB_ICONQUESTION | MB_YESNO) == IDNO )
                {
                    return 0;
                }
                else
                {
                    (*InfoPtr).IsRecModified  = FALSE;
                    SetButtonStatus(hWnd);
                }
            }
            (*InfoPtr ).Index--;
            if((*InfoPtr).Index < 0 )
            {
                (*InfoPtr).Index  = InfoPtr->MaxRecs - 1;
            }
            Udt2Dlg(hWnd);
            break;
        case IDM_HELP2:
            MessageBox(hWnd, _T("Help not implemented"), _T("Info"), MB_ICONINFORMATION);
            break;
        case IDM_ABOUT:
            MessageBox(hWnd, _T("Interface For A Small Database"), _T("Cardfile"), MB_OK);
            break;
        case IDC_PRINT:
            PrintRecord(hWnd);
            break;
        case IDC_DELETE:
            DeleteRecord(hWnd);
            break;
        case IDM_SAVE:
            if(InfoPtr->IsRecModified )
            {
                SaveFile(hWnd);
            }
            else
            {
                MessageBox(hWnd, _T("No changed data to save"), _T("Information"), MB_OK);
            }
            break;
        case IDC_ADD:
            InfoPtr->IsFileModified = TRUE;
            AddRecord(hWnd);
            InfoPtr->IsRecModified = FALSE;
            SetButtonStatus(hWnd);
            break;
        case IDC_UPDATE:
            InfoPtr->IsFileModified = TRUE;
            Dlg2Udt(hWnd);
            InfoPtr->IsRecModified = FALSE;
            SetButtonStatus(hWnd);
            break;
        }
        break;
    }
    return 0;
}


void AddRecord (HWND hWnd)
{
    AddressType  Address;
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArrayPtr;
    fstring  fs;
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    AddArrayPtr = InfoPtr->AddArrayPtr;
    GetWindowText(GetDlgItem(hWnd, IDC_COMPANY), Address.Company, sizeof(Address.Company));
    GetWindowText(GetDlgItem(hWnd, IDC_LASTNAME), Address.LastName, sizeof(Address.LastName));
    GetWindowText(GetDlgItem(hWnd, IDC_FIRSTNAME), Address.FirstName, sizeof(Address.FirstName));
    GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS1), Address.Address1, sizeof(Address.Address1));
    GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS2), Address.Address2, sizeof(Address.Address2));
    GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS3), Address.Address3, sizeof(Address.Address3));
    GetWindowText(GetDlgItem(hWnd, IDC_CITYNAME), Address.CityName, sizeof(Address.CityName));
    GetWindowText(GetDlgItem(hWnd, IDC_STATENAME), Address.StateName, sizeof(Address.StateName));
    GetWindowText(GetDlgItem(hWnd, IDC_ZIPCODE), Address.ZipCode, sizeof(Address.ZipCode));
    GetWindowText(GetDlgItem(hWnd, IDC_PHONE), Address.Phone, sizeof(Address.Phone));
    GetWindowText(GetDlgItem(hWnd, IDC_FAX), Address.Fax, sizeof(Address.Fax));
    GetWindowText(GetDlgItem(hWnd, IDC_EMAIL), Address.Email, sizeof(Address.Email));
    GetWindowText(GetDlgItem(hWnd, IDC_URL), Address.Url, sizeof(Address.Url));
    GetWindowText(GetDlgItem(hWnd, IDC_COMMENTS), Address.Comments, sizeof(Address.Comments));
    (*AddArrayPtr ).Add(Address);
    InfoPtr->MaxRecs = (* AddArrayPtr).GetSize();
    InfoPtr->Index = 0;
    Udt2Dlg(hWnd);
}


void DeleteRecord (HWND hWnd)
{
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArrayPtr;
    fstring  fs;
    int      IsRecMax = {0};
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    AddArrayPtr = InfoPtr->AddArrayPtr;
    if(InfoPtr->Index == InfoPtr->MaxRecs - 1 )
    {
        IsRecMax = TRUE;
    }
    if(MessageBox(hWnd, _T("Are you sure you want to delete this record?"), _T("Delete Record"), MB_ICONQUESTION | MB_YESNO) == IDNO )
    {
        return;
    }
    InfoPtr->IsFileModified = TRUE;
    (*AddArrayPtr ).Delete(InfoPtr->Index);
    InfoPtr->MaxRecs = (* AddArrayPtr).GetSize();
    if(IsRecMax )
    {
        InfoPtr->Index = InfoPtr->MaxRecs - 1;
    }
    Udt2Dlg(hWnd);
}


int DoSearch (HWND hWnd)
{
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArrayPtr;
    AddressType*  Aptr;
    fstring  fs;
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    AddArrayPtr = InfoPtr->AddArrayPtr;
    Aptr = ( AddressType*) AddArrayPtr->getptr();
    fstring  fsFind((*InfoPtr).findtext);
    int      i = {0};
    int      j = {0};
    int      k = {0};
    i = InfoPtr->StartRec;
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Company) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Company;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, LastName) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_LastName;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, FirstName) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_FirstName;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Address1) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Address;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Address2) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Address;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Address3) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Address;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, CityName) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_CityName;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, StateName) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_StateName;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, ZipCode) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_ZipCode;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Phone) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Phone;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Fax) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Fax;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Email) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Email;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Url) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Url;
        goto ALLDONE;
    }
    j = FindInType( fsFind.lpStr(), (_TCHAR*)Aptr + offsetof(AddressType, Comments) / sizeof(_TCHAR), sizeof(AddressType) / sizeof(_TCHAR), i, InfoPtr->MaxRecs, 3);
    if(j > -1 )
    {
        k = C_Comments;
    }

ALLDONE:
    ;
    if(j > -1 )
    {
        _TCHAR     s[32] = {0};
        GetWindowText(CTLHNDL(k), s, 32);
        InfoPtr->Index = j;
        Udt2Dlg(hWnd);
        fs = _T("  ");
        fs += fsFind;
        fs += _T(" was found in Record#");
        fs += fstring(j + 1);
        fs += _T(" at ");
        fs += s;
        SetWindowText(InfoPtr->hStatus, fs.lpStr());
        InfoPtr->StartRec = j + 1;
    }
    else
    {
        Beep(750, 400);
        fs = _T("  ");
        fs += fsFind;
        fs += _T(" was not found");
        SetWindowText(InfoPtr->hStatus, fs.lpStr());
        InfoPtr->StartRec = 0;
        InfoPtr->Index = 0;
        Udt2Dlg(hWnd);
        SetTimer(hWnd, 1, 2000, NULL);
        return -1;
    }
    return 0;
}


int DoFindDlg (HWND hWnd)
{
    DlgInfoType*  InfoPtr;
    int      RetVal = {0};
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    InfoPtr->StartRec = 0;
    SetWindowText(InfoPtr->hStatus, _T(""));
    RetVal = DialogBoxParam((* InfoPtr).hInst, MAKEINTRESOURCE( IDD_DLG2), hWnd, FindDlgProc, 0);
    return RetVal;
}


INT_PTR CALLBACK FindDlgProc (HWND hWnd, UINT Msg, WPARAM  wParam, LPARAM  lParam)
{
    static HWND     hParent;
    static HWND     hFindText;
    static DlgInfoType*  InfoPtr;
    int      RetVal = {0};
    switch(Msg)
    {
    case WM_INITDIALOG:
        hParent = GetParent( hWnd);
        InfoPtr = ( DlgInfoType*) GetProp( hParent, _T("DLGINFO"));
        hFindText = CTLHNDL( IDC_DLG2_EDT1);
        break;
    case WM_CLOSE:
        EndDialog(hWnd, 0);
        break;
    case WM_COMMAND:
        switch LOWORD(wParam)
        {
        case IDC_DLG2_BTN2:
            if(HIWORD(wParam) == BN_CLICKED )
            {
                SetWindowText(InfoPtr->hStatus, _T(""));
                SendMessage(hWnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
                return 0;
            }
            break;
        case IDC_DLG2_EDT1:
            if(HIWORD(wParam) == EN_UPDATE )
            {
                GetWindowText(hFindText, (*InfoPtr ).findtext, sizeof((*InfoPtr ).findtext));
            }
            break;
        case IDC_DLG2_BTN1:
            if(HIWORD(wParam) == BN_CLICKED )
            {
                RetVal = DoSearch( hParent);
                if(RetVal )
                {
                    SendMessage(hWnd, (UINT)WM_CLOSE, (WPARAM)0, (LPARAM)0);
                    return 0;
                }
            }
            break;
        }
        break;
    }
    return 0;
}


void AddCountries (HWND hCtl)
{
    int      OrgLen = {0};
    int      CmpLen = {0};
    int      i = {0};
    int      iParseCount = {0};
    HRSRC    hResFind = {0};
    HGLOBAL  hResLoad = {0};
    LPVOID   pResData = {0};
    LPVOID   lpData = {0};
    LPVOID   DestBuf = {0};
    int*     iPtr = {0};
    fstring  fs;
    fstring*  pStrs;
    hResFind = FindResource( 0, MAKEINTRESOURCE( 100), MAKEINTRESOURCE( RT_RCDATA));
    if(hResFind )
    {
        hResLoad = LoadResource( 0, hResFind);
        if(hResLoad )
        {
            pResData = LockResource( hResLoad);
            if(pResData )
            {
                iPtr = ( int*) pResData;
                OrgLen = * iPtr;
                iPtr++;
                CmpLen = * iPtr;
                iPtr++;
                lpData = iPtr;
                fs.Make(0, OrgLen + 1);
                tcl_depack_asm_fast(lpData, fs.lpStr());
                iParseCount = fs.ParseCount(',');
                pStrs = new  fstring[iParseCount];
                fs.Parse(pStrs, (','), iParseCount);
                for(i = 0; i <= iParseCount - 2; i += 1)
                {
                    SendMessage(hCtl, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)pStrs[i].lpStr());
                }

                SendMessage(hCtl, (UINT)CB_SETCURSEL, (WPARAM)214, (LPARAM)0);
                delete[] pStrs;
            }
        }
    }
    SendMessage(hCtl, (UINT)CB_SETMINVISIBLE, (WPARAM)10, (LPARAM)0);
}


void Udt2Dlg (HWND hWnd)
{
    fstring  fs;
    int      SaveState = {0};
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArray;
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    SaveState = InfoPtr->IsRecModified;
    InfoPtr->IsRecModified = TRUE;
    AddArray = InfoPtr->AddArrayPtr;
    fs = fstring( InfoPtr->Index + 1) + _T("/") + fstring((* AddArray).GetSize());
    SetWindowText(GetDlgItem(hWnd, IDC_INDEX), fs.lpStr());
    SetWindowText(GetDlgItem(hWnd, IDC_COMPANY), (*AddArray )[InfoPtr->Index].Company);
    SetWindowText(GetDlgItem(hWnd, IDC_FIRSTNAME), (*AddArray )[InfoPtr->Index].FirstName);
    SetWindowText(GetDlgItem(hWnd, IDC_LASTNAME), (*AddArray )[InfoPtr->Index].LastName);
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS1), (*AddArray )[InfoPtr->Index].Address1);
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS2), (*AddArray )[InfoPtr->Index].Address2);
    SetWindowText(GetDlgItem(hWnd, IDC_ADDRESS3), (*AddArray )[InfoPtr->Index].Address3);
    SetWindowText(GetDlgItem(hWnd, IDC_CITYNAME), (*AddArray )[InfoPtr->Index].CityName);
    SetWindowText(GetDlgItem(hWnd, IDC_STATENAME), (*AddArray )[InfoPtr->Index].StateName);
    SetWindowText(GetDlgItem(hWnd, IDC_ZIPCODE), (*AddArray )[InfoPtr->Index].ZipCode);
    SetWindowText(GetDlgItem(hWnd, IDC_PHONE), (*AddArray )[InfoPtr->Index].Phone);
    SetWindowText(GetDlgItem(hWnd, IDC_FAX), (*AddArray )[InfoPtr->Index].Fax);
    SetWindowText(GetDlgItem(hWnd, IDC_EMAIL), (*AddArray )[InfoPtr->Index].Email);
    SetWindowText(GetDlgItem(hWnd, IDC_URL), (*AddArray )[InfoPtr->Index].Url);
    SetWindowText(GetDlgItem(hWnd, IDC_COMMENTS), (*AddArray )[InfoPtr->Index].Comments);
    InfoPtr->IsRecModified = SaveState;
}


void Dlg2Udt (HWND hWnd)
{
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArray;
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    AddArray = InfoPtr->AddArrayPtr;
    fstring  fs;
    GetWindowText(GetDlgItem(hWnd, IDC_COMPANY), (*AddArray )[InfoPtr->Index].Company, sizeof((*AddArray )[InfoPtr->Index].Company));
    GetWindowText(GetDlgItem(hWnd, IDC_LASTNAME), (*AddArray )[InfoPtr->Index].LastName, sizeof((*AddArray )[InfoPtr->Index].LastName));
    GetWindowText(GetDlgItem(hWnd, IDC_FIRSTNAME), (*AddArray )[InfoPtr->Index].FirstName, sizeof((*AddArray )[InfoPtr->Index].FirstName));
    GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS1), (*AddArray )[InfoPtr->Index].Address1, sizeof((*AddArray )[InfoPtr->Index].Address1));
    GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS2), (*AddArray )[InfoPtr->Index].Address2, sizeof((*AddArray )[InfoPtr->Index].Address2));
    GetWindowText(GetDlgItem(hWnd, IDC_ADDRESS3), (*AddArray )[InfoPtr->Index].Address3, sizeof((*AddArray )[InfoPtr->Index].Address3));
    GetWindowText(GetDlgItem(hWnd, IDC_CITYNAME), (*AddArray )[InfoPtr->Index].CityName, sizeof((*AddArray )[InfoPtr->Index].CityName));
    GetWindowText(GetDlgItem(hWnd, IDC_STATENAME), (*AddArray )[InfoPtr->Index].StateName, sizeof((*AddArray )[InfoPtr->Index].StateName));
    GetWindowText(GetDlgItem(hWnd, IDC_ZIPCODE), (*AddArray )[InfoPtr->Index].ZipCode, sizeof((*AddArray )[InfoPtr->Index].ZipCode));
    GetWindowText(GetDlgItem(hWnd, IDC_PHONE), (*AddArray )[InfoPtr->Index].Phone, sizeof((*AddArray )[InfoPtr->Index].Phone));
    GetWindowText(GetDlgItem(hWnd, IDC_FAX), (*AddArray )[InfoPtr->Index].Fax, sizeof((*AddArray )[InfoPtr->Index].Fax));
    GetWindowText(GetDlgItem(hWnd, IDC_EMAIL), (*AddArray )[InfoPtr->Index].Email, sizeof((*AddArray )[InfoPtr->Index].Email));
    GetWindowText(GetDlgItem(hWnd, IDC_URL), (*AddArray )[InfoPtr->Index].Url, sizeof((*AddArray )[InfoPtr->Index].Url));
    GetWindowText(GetDlgItem(hWnd, IDC_COMMENTS), (*AddArray )[InfoPtr->Index].Comments, sizeof((*AddArray )[InfoPtr->Index].Comments));
}


int PrintRecord (HWND hWnd)
{
    DlgInfoType*  InfoPtr;
    AddressTypeArray*  AddArray;
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    AddArray = InfoPtr->AddArrayPtr;
    fstring  fsRec;
    fstring  fsBuffer;
    HFONT    hFont = {0};
    HFONT    hOldFont = {0};
    TEXTMETRIC  tm = {0};
    int      xChar = {0};
    int      yChar = {0};
    int      xPage = {0};
    int      yPage = {0};
    int      i = {0};
    int      iLineCount = {0};
    int      iCharsCopied = {0};
    DWORD    dwBytes = 128;
    DWORD    nBufferSize = 1024;
    DWORD*   dwPtr;
    DWORD    dwWord = {0};
    RECT     rc = {0};
    HDC      hdcPrn = {0};
    DOCINFO  di = {sizeof(DOCINFO), _T("Print1: Printing")};
    HWND     hCtl = {0};
    fsBuffer.Make(0, nBufferSize);
    GetDefaultPrinter(fsBuffer.lpStr(), &dwBytes);
    hdcPrn = CreateDC( NULL, fsBuffer.lpStr(), NULL, NULL);
    if(hdcPrn == NULL )
    {
        return -1;
    }
    hFont = CreateFont(- 1 * ( 15 * GetDeviceCaps( hdcPrn, LOGPIXELSY)) / 72, 0, 0, 0, FW_HEAVY, 0, TRUE, 0, 0, 0, 0, 0, 0, _T("Ariel"));
    fsRec.Make(0, 32);
    GetWindowText(GetDlgItem(hWnd, IDC_INDEX), fsRec.lpStr(), fsRec.Len());
    fstring  fs(_T("Address Book, Record "));
    fs += fsRec;
    xPage = GetDeviceCaps( hdcPrn, HORZRES);
    yPage = GetDeviceCaps( hdcPrn, VERTRES);
    if(StartDoc(hdcPrn, &di) > 0 )
    {
        if(StartPage(hdcPrn) > 0 )
        {
            hOldFont = ( HFONT) SelectObject( hdcPrn, hFont);
            GetTextMetrics(hdcPrn, &tm);
            yChar = tm.tmHeight + tm.tmExternalLeading;
            xChar = tm.tmAveCharWidth;
            rc.top = 200;
            rc.bottom = rc.top + yChar;
            rc.left = 0;
            rc.right = xPage;
            DrawText(hdcPrn, fs.lpStr(), -1, &rc, DT_CENTER);
            DeleteObject(SelectObject(hdcPrn, hOldFont));
            hFont = CreateFont(- 1 * ( 11 * GetDeviceCaps( hdcPrn, LOGPIXELSY)) / 72, 0, 0, 0, FW_HEAVY, 0, 0, 0, 0, 0, 0, 0, 0, _T("Ariel"));
            hOldFont = ( HFONT) SelectObject( hdcPrn, hFont);
            GetTextMetrics(hdcPrn, &tm);
            yChar = tm.tmHeight + tm.tmExternalLeading + 20;
            xChar = tm.tmAveCharWidth;
            TextOut(hdcPrn, 300, 600, _T("Company:"), 8);
            TextOut(hdcPrn, 300, 600 + 1 * yChar, _T("Name:"), 5);
            TextOut(hdcPrn, 300, 600 + 3 * yChar, _T("Address:"), 8);
            TextOut(hdcPrn, 300, 600 + 4 * yChar, _T("City:"), 5);
            TextOut(hdcPrn, 300, 600 + 5 * yChar, _T("State/Prov:"), 11);
            TextOut(hdcPrn, 300, 600 + 6 * yChar, _T("Zip/Postal:"), 11);
            TextOut(hdcPrn, 300, 600 + 7 * yChar, _T("Country:"), 8);
            TextOut(hdcPrn, 300, 600 + 9 * yChar, _T("Phone:"), 6);
            TextOut(hdcPrn, 300, 600 + 10 * yChar, _T("Fax:"), 4);
            TextOut(hdcPrn, 300, 600 + 11 * yChar, _T("Email:"), 6);
            TextOut(hdcPrn, 300, 600 + 12 * yChar, _T("Url:"), 4);
            TextOut(hdcPrn, 300, 600 + 14 * yChar, _T("Comments:"), 9);
            DeleteObject(SelectObject(hdcPrn, hOldFont));
            fsBuffer = (* AddArray)[InfoPtr->Index].Company;
            TextOut(hdcPrn, 1000, 600, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].FirstName;
            fsBuffer += _T(" ");
            fsBuffer += (*AddArray )[InfoPtr->Index].LastName;
            TextOut(hdcPrn, 1000, 600 + 1 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].Address1;
            TextOut(hdcPrn, 1000, 600 + 3 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].CityName;
            TextOut(hdcPrn, 1000, 600 + 4 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].StateName;
            TextOut(hdcPrn, 1000, 600 + 5 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].ZipCode;
            TextOut(hdcPrn, 1000, 600 + 6 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer.Make(0, 128);
            hCtl = GetDlgItem( hWnd, IDC_COUNTRY);
            GetWindowText(hCtl, fsBuffer.lpStr(), 128);
            TextOut(hdcPrn, 1000, 600 + 7 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].Phone;
            TextOut(hdcPrn, 1000, 600 + 9 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].Fax;
            TextOut(hdcPrn, 1000, 600 + 10 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].Email;
            TextOut(hdcPrn, 1000, 600 + 11 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            fsBuffer = (* AddArray)[InfoPtr->Index].Url;
            TextOut(hdcPrn, 1000, 600 + 12 * yChar, fsBuffer.lpStr(), fsBuffer.Len());
            hCtl = GetDlgItem( hWnd, IDC_COMMENTS);
            iLineCount = SendMessage( hCtl, ( UINT) EM_GETLINECOUNT, ( WPARAM) 0, ( LPARAM) 0);
            fsBuffer.Make(0, 1024);
            dwPtr = ( DWORD*) fsBuffer.lpStr();
            for(i = 0; i <= iLineCount - 1; i += 1)
            {
                *dwPtr = MAKELONG( 1024, 0);
                iCharsCopied = SendMessage( hCtl, ( UINT) EM_GETLINE, ( WPARAM) i, ( LPARAM) fsBuffer.lpStr());
                TextOut(hdcPrn, 1000, 600 + (15 + i)*yChar, fsBuffer.lpStr(), iCharsCopied);
            }

            if(EndPage(hdcPrn) > 0 )
            {
                EndDoc(hdcPrn);
            }
        }
    }
    DeleteDC(hdcPrn);
    return 0;
}


void SetButtonStatus (HWND hWnd)
{
    DlgInfoType*  InfoPtr = {0};
    InfoPtr = ( DlgInfoType*) GetProp( hWnd, _T("DLGINFO"));
    if(InfoPtr->IsRecModified )
    {
        EnableWindow(CTLHNDL(IDC_ADD), TRUE);
        EnableWindow(CTLHNDL(IDC_UPDATE), TRUE);
    }
    else
    {
        EnableWindow(CTLHNDL(IDC_ADD), FALSE);
        EnableWindow(CTLHNDL(IDC_UPDATE), FALSE);
    }
}



