$NOMAIN
$CPP
$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "TCLIB.BAT $FILE$"
'==============================================================================
$HEADER
	#include "aedynarray.h"
	#include <commctrl.h> 
	#pragma comment(lib,"gdi32.lib")
	#pragma comment(lib,"Winspool.lib")
	struct AddressType;
	typedef AeDynArray<AddressType> AddressTypeArray;
$HEADER
'==============================================================================
$IPRINT_OFF
CONST IDD_DLG1 = 1000
CONST IDC_STC20 = 1001
CONST IDC_INDEX = 1002
CONST IDC_STC21 = 1003
CONST IDC_COMPANY = 1004
CONST IDC_STC22 = 1005
CONST IDC_LASTNAME = 1006
CONST IDC_STC23 = 1007
CONST IDC_FIRSTNAME = 1008
CONST IDC_STC24 = 1009
CONST IDC_ADDRESS1 = 1010
CONST IDC_ADDRESS2 = 1011
CONST IDC_ADDRESS3 = 1012
CONST IDC_STC25 = 1013
CONST IDC_CITYNAME = 1014
CONST IDC_STC26 = 1015
CONST IDC_STATENAME = 1016
CONST IDC_STC27 = 1017
CONST IDC_ZIPCODE = 1018
CONST IDC_STC28 = 1019
CONST IDC_COUNTRY = 1020
CONST IDC_STC29 = 1021
CONST IDC_PHONE = 1022
CONST IDC_STC30 = 1023
CONST IDC_FAX = 1024
CONST IDC_STC31 = 1025
CONST IDC_EMAIL = 1026
CONST IDC_STC32 = 1027
CONST IDC_URL = 1028
CONST IDC_STC33 = 1039
CONST IDC_COMMENTS = 1029
CONST IDC_PRIOR = 1030
CONST IDC_NEXT = 1031
CONST IDC_FIND = 1032
CONST IDC_ADD = 1033
CONST IDC_UPDATE = 1034
CONST IDC_DELETE = 1035
CONST IDC_PRINT = 1036
CONST IDC_SBR1 = 1037
CONST IDC_LSV1 = 1038
CONST IDR_MENU1 = 10000
CONST IDM_SAVE = 10001
CONST IDM_HELP2 = 10004
CONST IDM_ABOUT = 10005
CONST IDD_DLG2 = 1100
CONST IDC_DLG2_STC1 = 1101
CONST IDC_DLG2_EDT1 = 1102
CONST IDC_DLG2_BTN1 = 1103
CONST IDC_DLG2_BTN2 = 1104

'------------------------------------------------------------------------------
'For use in search to display where item in record was found
'------------------------------------------------------------------------------
CONST C_Company      = IDC_STC21
CONST C_LastName     = IDC_STC22
CONST C_FirstName    = IDC_STC23
CONST C_Address      = IDC_STC24
CONST C_CityName     = IDC_STC25
CONST C_StateName    = IDC_STC26
CONST C_ZipCode      = IDC_STC27
CONST C_Phone        = IDC_STC29
CONST C_Fax          = IDC_STC30
CONST C_Email        = IDC_STC31
CONST C_Url          = IDC_STC32
CONST C_Comments     = IDC_STC33
'==============================================================================
PPType AddressType
	Dim As char Company[64]
	Dim As char LastName[32]
    Dim As char FirstName[32]
    Dim As char Address1[64]
    Dim As char Address2[64]
    Dim As char Address3[64]
    Dim As char CityName[24]
    Dim As char StateName[4]
    Dim As char ZipCode[12]
    Dim As long Country
    Dim As char Phone[24]
    Dim As char Fax[24]
    Dim As char Email[64]
    Dim As char Url[64]
    Dim As char Comments[1024]
End PPType
'------------------------------------------------------------------------------
PPType DlgInfoType
	Dim As AddressTypeArray Ptr AddArrayPtr
	Dim As Integer Index
	Dim As Integer IsRecModified
	Dim As Integer IsFileModified
	Dim AS Integer StartRec
	Dim As HINSTANCE hInst
	Dim As HWND hParent
	Dim As HWND hStatus
	Dim As char findtext[1024]
	Dim As Integer MaxRecs
	Dim As char dbfile[2048]
End PPType
'==============================================================================
Function GetData( hWnd As HWND) As Integer
	Raw As AddressType Address
	Dim As HANDLE hFile
	Dim As Integer RecSize,Count
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArrayPtr
	Raw As fstring fs

	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	AddArrayPtr = InfoPtr->AddArrayPtr
	RecSize = Sizeof(AddressType)
	Raw As fstring fsFile(InfoPtr->dbfile)
	OpenFile fsFile For Input As hFile
	While FGet(hFile,&Address,RecSize)
		(*AddArrayPtr).Add(Address)
		Count++
	Wend
	CloseHandle(hFile)
	Function = Count
End Function
'==============================================================================
Sub SaveFile(hWnd As HWND)
	Raw As AddressType Address
	Dim As HANDLE hFile
	Dim As Integer RecSize,Count,where,i
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArrayPtr
	Raw As fstring fs
	Dim As SYSTEMTIME st
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	AddArrayPtr = InfoPtr->AddArrayPtr
	
	RecSize = Sizeof(AddressType)
	Raw As fstring fsFile(InfoPtr->dbfile)
	GetSystemTime(&st)
	where = fsFile.InStr(".",_false,_true)
	where--
	fs = fsFile.Left(where)
	fs+="-"
	fs+=(fstring(st.wYear))
	fs+="-"
	fs+=(fstring(st.wMonth))
	fs+="-"
	fs+=(fstring(st.wDay))
	fs+="-"
	fs+=(fstring(st.wHour))
	fs+="-"
	fs+=(fstring(st.wMinute))
	fs+=".bin" 
	Rename fsFile.lpStr(),fs.lpStr()
	OpenFile fsFile For Output As hFile
	FPut(hFile,(*AddArrayPtr).getptr(),Sizeof(AddressType)*InfoPtr->MaxRecs)
	CloseHandle(hFile) 
End Sub
'==============================================================================
Function WinMain()
    Local As HWND hDlg 
    Local As MSG Msg
    Raw As AddressTypeArray AddArray
    Raw As DlgInfoType DlgInfo
	DlgInfo.hInst = hInst
	DlgInfo.dbfile$ = "CardFile50.bin"
	DlgInfo.AddArrayPtr = &AddArray
	DlgInfo.Index = 0

    hDlg = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_DLG1),0,DlgProc,(LPARAM)&DlgInfo)
    
    While GetMessage(&Msg,NULL, 0, 0)
        If (IsDialogMessage(hDlg, &Msg) = 0) Then
            TranslateMessage(&Msg)
            DispatchMessage(&Msg)
        End If
    Wend

    Function = Msg.wParam    

End Function
'==============================================================================
'==============================================================================
Function DlgProc (hWnd As HWND, Msg As UINT , wParam As WPARAM  ,lParam As  LPARAM ) As INT_PTR Callback
    static As AddressTypeArray Ptr AddArrayPtr
    static As DlgInfoType Ptr InfoPtr


    _switch(CBMSG)
    BeginBlock
    	_case WM_TIMER
    		If CBWPARAM = 1 Then
    			SetWindowText((*InfoPtr).hStatus,"")
    			KillTimer(CBHNDL,1)
    		EndIf
    		break
    	_case WM_INITDIALOG
    		AddCountries(CTLHNDL(IDC_COUNTRY))
    		InfoPtr = (DlgInfoType*)lParam
    		SetProp(hWnd,"DLGINFO",InfoPtr)
    		AddArrayPtr = (*InfoPtr).AddArrayPtr
    		(*InfoPtr).Index = 0
    		InfoPtr->MaxRecs = GetData(CBHNDL)
    		Udt2Dlg(CBHNDL)
    		SetFocus(CTLHNDL(IDC_NEXT))
    		(*InfoPtr).hStatus = CTLHNDL(IDC_SBR1)
    		(*InfoPtr).IsRecModified = FALSE
    		SetButtonStatus(CBHNDL)
    		break
        _case WM_CLOSE
            'Beep( 750, 400 )
        	If InfoPtr->IsRecModified Then
        		If MessageBox(CBHNDL,"Record data has been changed\nDo you wish to Cancel Add/Update?","Add/Update Abort Confirm",MB_ICONQUESTION | MB_YESNO) = IDNO Then
        			Function = 1
        			break
        		EndIf
        	EndIf
        	If InfoPtr->IsFileModified Then
        		If MessageBox(CBHNDL,"Record data has been changed\nDo you wish to Save","Save Records to File",MB_ICONQUESTION | MB_YESNO) = IDYES Then
        			SaveFile(CBHNDL)
        		EndIf
        	EndIf
        	DestroyWindow(CBHWND)
            break
        _case WM_DESTROY
        	RemoveProp(hWnd,"DLGINFO")
            PostQuitMessage(0)
            Function = 0   
            break 
        _case WM_COMMAND
        	If CBCTLMSG = EN_UPDATE OR (CBCTL = IDC_COUNTRY AND CBCTLMSG = CBN_SELCHANGE) Then
        		If InfoPtr->IsRecModified = FALSE Then
        			InfoPtr->IsRecModified = TRUE
        			InfoPtr->IsFileModified = TRUE
        			SetButtonStatus(CBHNDL)
        		EndIf
        	EndIf
            _switch(CBCTL)
            BeginBlock
                _case IDCANCEL
                    SendMessage(CBHWND,WM_CLOSE,0,0)
                    break
                _case IDC_FIND
                	DoFindDlg(CBHNDL)
                    break
                _case IDC_NEXT
                	If (*InfoPtr).IsRecModified Then
                		If MessageBox(CBHNDL,"Record data has been changed\nDo you wish to Cancel Add/Update?","Add/Update Abort Confirm",MB_ICONQUESTION | MB_YESNO) = IDNO Then
                			Exit Function
                		Else
                			(*InfoPtr).IsRecModified = FALSE
                			SetButtonStatus(CBHNDL)
                		EndIf
                	EndIf
                	(*InfoPtr).Index++
                	If (*InfoPtr).Index > InfoPtr->MaxRecs - 1 Then
                		(*InfoPtr).Index = 0
                	EndIf
                	Udt2Dlg(CBHNDL)
                	break
                _case IDC_PRIOR
                	If (*InfoPtr).IsRecModified Then
                		If MessageBox(CBHNDL,"Record data has been changed\nDo you wish to Cancel Add/Update?","Add/Update Abort Confirm",MB_ICONQUESTION | MB_YESNO) = IDNO Then
                			Exit Function
                		Else
                			(*InfoPtr).IsRecModified = FALSE
                			SetButtonStatus(CBHNDL)
                		EndIf
                	EndIf
                	(*InfoPtr).Index--
                	If (*InfoPtr).Index < 0 Then
                		(*InfoPtr).Index = InfoPtr->MaxRecs - 1
                	EndIf
                	Udt2Dlg(CBHNDL)
                	break
                _case IDM_HELP2
					MessageBox(CBHWND,"Help not implemented","Info",MB_ICONINFORMATION)	
					break                 
				_case IDM_ABOUT
					MessageBox(CBHWND,"Interface For A Small Database","Cardfile",MB_OK)	
					break
				_case IDC_PRINT
					PrintRecord(CBHNDL)
					break
				_case IDC_DELETE
					DeleteRecord(CBHNDL)
					break	
				_case IDM_SAVE
					If InfoPtr->IsRecModified Then
						SaveFile(CBHNDL)
					Else
						MessageBox(CBHNDL,"No changed data to save","Information",MB_OK)
					EndIf
					break
				_case IDC_ADD
					InfoPtr->IsFileModified = TRUE
					AddRecord(CBHNDL)
					InfoPtr->IsRecModified = FALSE 
					SetButtonStatus(CBHNDL)
					break
				_case IDC_UPDATE
					InfoPtr->IsFileModified = TRUE
					Dlg2Udt(CBHNDL)
					InfoPtr->IsRecModified = FALSE 
					SetButtonStatus(CBHNDL)
					break
            EndBlock
            break
    EndBlock
	Function = 0	
End Function
'==============================================================================
Sub AddRecord(hWnd As HWND)
	Raw As AddressType Address
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArrayPtr
	Raw As fstring fs
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	AddArrayPtr = InfoPtr->AddArrayPtr
	GetWindowText(GetDlgItem(hWnd,IDC_COMPANY),Address.Company,Sizeof(Address.Company))
	GetWindowText(GetDlgItem(hWnd,IDC_LASTNAME),Address.LastName,Sizeof(Address.LastName))
	GetWindowText(GetDlgItem(hWnd,IDC_FIRSTNAME),Address.FirstName,Sizeof(Address.FirstName))
	GetWindowText(GetDlgItem(hWnd,IDC_ADDRESS1),Address.Address1,Sizeof(Address.Address1))
	GetWindowText(GetDlgItem(hWnd,IDC_ADDRESS2),Address.Address2,Sizeof(Address.Address2))
	GetWindowText(GetDlgItem(hWnd,IDC_ADDRESS3),Address.Address3,Sizeof(Address.Address3))
	GetWindowText(GetDlgItem(hWnd,IDC_CITYNAME),Address.CityName,Sizeof(Address.CityName))
	GetWindowText(GetDlgItem(hWnd,IDC_STATENAME),Address.StateName,Sizeof(Address.StateName))
	GetWindowText(GetDlgItem(hWnd,IDC_ZIPCODE),Address.ZipCode,Sizeof(Address.ZipCode))
	GetWindowText(GetDlgItem(hWnd,IDC_PHONE),Address.Phone,Sizeof(Address.Phone))
	GetWindowText(GetDlgItem(hWnd,IDC_FAX),Address.Fax,Sizeof(Address.Fax))
	GetWindowText(GetDlgItem(hWnd,IDC_EMAIL),Address.Email,Sizeof(Address.Email))
	GetWindowText(GetDlgItem(hWnd,IDC_URL),Address.Url,Sizeof(Address.Url))
	GetWindowText(GetDlgItem(hWnd,IDC_COMMENTS),Address.Comments,Sizeof(Address.Comments))
	(*AddArrayPtr).Add(Address)
	InfoPtr->MaxRecs = (*AddArrayPtr).GetSize()
	InfoPtr->Index = 0
 	Udt2Dlg(hWnd)
End Sub
'==============================================================================
Sub DeleteRecord(hWnd As HWND)
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArrayPtr
	Raw As fstring fs
	Dim As Integer IsRecMax
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	AddArrayPtr = InfoPtr->AddArrayPtr
	If InfoPtr->Index = InfoPtr->MaxRecs -1  Then
		IsRecMax = TRUE
	EndIf
	If MessageBox(hWnd,"Are you sure you want to delete this record?","Delete Record",MB_ICONQUESTION | MB_YESNO) = IDNO Then
		Exit Sub
	EndIf
	InfoPtr->IsFileModified = TRUE
	(*AddArrayPtr).Delete(InfoPtr->Index)
	InfoPtr->MaxRecs = (*AddArrayPtr).GetSize() 
	If IsRecMax Then
		InfoPtr->Index = InfoPtr->MaxRecs-1
	EndIf
	Udt2Dlg(hWnd)
End Sub
'==============================================================================
Function DoSearch(hWnd As HWND) As Integer
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArrayPtr
	Raw As AddressType Ptr  Aptr
	Raw As fstring fs
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	AddArrayPtr = InfoPtr->AddArrayPtr
	Aptr = (AddressType*)AddArrayPtr->getptr()

	Raw As fstring fsFind((*InfoPtr).findtext)
	Dim As Integer i,j,k
	
	i = InfoPtr->StartRec

	j = FindInType(fsFind.lpStr(),Aptr.Company,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Company
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.LastName,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_LastName
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.FirstName,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_FirstName
		goto AllDone
	EndIf

	j = FindInType(fsFind.lpStr(),Aptr.Address1,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Address
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.Address2,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Address
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.Address3,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Address
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.CityName,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_CityName
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.StateName,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_StateName
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.ZipCode,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_ZipCode
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.Phone,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Phone
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.Fax,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Fax
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.Email,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Email
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.Url,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Url
		goto AllDone
	EndIf
	
	j = FindInType(fsFind.lpStr(),Aptr.Comments,i,InfoPtr->MaxRecs,3)
	If j > -1 Then
		k = C_Comments
	EndIf
	
	
AllDone:
	If j > -1 Then
		Dim As char s[32]
		GetWindowText(CTLHNDL(k),s,32)
		InfoPtr->Index = j
		Udt2Dlg(hWnd)
		fs = "  "
		fs += fsFind
		fs += " was found in Record#"
		fs += fstring(j+1)
		fs += " at "
		fs += s
		SetWindowText(InfoPtr->hStatus,fs.lpStr())
		InfoPtr->StartRec = j + 1
	Else
		Beep( 750, 400 )
		fs = "  "
		fs += fsFind
		fs += " was not found"
 		SetWindowText(InfoPtr->hStatus,fs.lpStr())
 		InfoPtr->StartRec = 0
 		InfoPtr->Index = 0
 		Udt2Dlg(hWnd)
 		SetTimer(hWnd,1,2000,NULL)
 		Function = -1
	End If

	Function = 0
End Function
'==============================================================================
Function DoFindDlg(hWnd As HWND)
	Raw As DlgInfoType Ptr InfoPtr
	Dim AS Integer RetVal
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	InfoPtr->StartRec = 0
	SetWindowText(InfoPtr->hStatus,"")
	RetVal = DialogBoxParam((*InfoPtr).hInst,MAKEINTRESOURCE(IDD_DLG2),hWnd,FindDlgProc,0)
	Function = RetVal
End Function
'==============================================================================
Function FindDlgProc(hWnd As HWND,Msg As UINT,wParam As WPARAM,lParam AS LPARAM) As INT_PTR Callback
	static As HWND hParent,hFindText
	static As DlgInfoType Ptr InfoPtr 
	Dim As Integer RetVal
	_switch(CBMSG)
	BeginBlock
		_case WM_INITDIALOG
			hParent = GetParent(CBHNDL)
			InfoPtr = (DlgInfoType*)GetProp(hParent,"DLGINFO")
			hFindText = CTLHNDL(IDC_DLG2_EDT1)
			break
		_case WM_CLOSE
			EndDialog(CBHNDL,0)
			break
		_case WM_COMMAND
			_switch CBCTL
			BeginBlock
				_case IDC_DLG2_BTN2
					If CBCTLMSG= BN_CLICKED Then
						SetWindowText(InfoPtr->hStatus,"")
						SendMessage(CBHNDL,WM_CLOSE,0,0)
						Exit Function
					End If	
					break
				_case IDC_DLG2_EDT1
					If CBCTLMSG = EN_UPDATE Then
						GetWindowText(hFindText,(*InfoPtr).findtext,sizeof((*InfoPtr).findtext))
					EndIf
					break
				_case IDC_DLG2_BTN1
					If CBCTLMSG= BN_CLICKED Then
						RetVal = DoSearch(hParent)
						If RetVal  Then
							SendMessage(CBHNDL,WM_CLOSE,0,0)
							Exit Function
						EndIf
					End If	
					break
			EndBlock						
			break	
	EndBlock

	Function = 0
End Function
'==============================================================================
Sub AddCountries(hCtl As HWND)
	Dim As int OrgLen,CmpLen,i,iParseCount
	Dim As HRSRC hResFind
	Dim As HGLOBAL hResLoad
	Dim As LPVOID pResData,lpData,DestBuf
	Dim As int ptr iPtr
	Raw As fstring fs
	Raw As fstring Ptr pStrs
	hResFind = FindResource(0,MAKEINTRESOURCE(100),MAKEINTRESOURCE(RT_RCDATA))
	If hResFind Then
		hResLoad = LoadResource(0,hResFind)
		If hResLoad Then
			pResData = LockResource(hResLoad)
			If pResData Then
				iPtr = (int*)pResData
				OrgLen = *iPtr
				iPtr++
				CmpLen = *iPtr
				iPtr++
				lpData = iPtr
				fs.Make(0,OrgLen+1)
				tcl_depack_asm_fast(lpData,fs.lpStr())
				iParseCount = fs.ParseCount(E"','")
				pStrs = new fstring[iParseCount]
				fs.Parse(pStrs,(E"','"),iParseCount)
				For i = 0 To iParseCount - 2
					SendMessage(hCtl,CB_ADDSTRING,0,pStrs[i].lpStr())
				Next
				SendMessage(hCtl,CB_SETCURSEL,214,0)
				delete [] pStrs
			End If	
		End if	
	EndIf
	SendMessage(hCtl,CB_SETMINVISIBLE,10,0)
End Sub
'==============================================================================
Sub Udt2Dlg(hWnd As HWND)
	Raw As fstring fs
	Dim AS Integer SaveState
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArray
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	SaveState = InfoPtr->IsRecModified
	InfoPtr->IsRecModified = TRUE
	AddArray = InfoPtr->AddArrayPtr
	fs = fstring(InfoPtr->Index+1) + "/" + fstring((*AddArray).GetSize())
	SetWindowText(GetDlgItem(hWnd,IDC_INDEX),fs.lpStr())
	SetWindowText(GetDlgItem(hWnd,IDC_COMPANY),(*AddArray)[InfoPtr->Index].Company)
	SetWindowText(GetDlgItem(hWnd,IDC_FIRSTNAME),(*AddArray)[InfoPtr->Index].FirstName)
	SetWindowText(GetDlgItem(hWnd,IDC_LASTNAME),(*AddArray)[InfoPtr->Index].LastName)
	SetWindowText(GetDlgItem(hWnd,IDC_ADDRESS1),(*AddArray)[InfoPtr->Index].Address1)
	SetWindowText(GetDlgItem(hWnd,IDC_ADDRESS2),(*AddArray)[InfoPtr->Index].Address2)
	SetWindowText(GetDlgItem(hWnd,IDC_ADDRESS3),(*AddArray)[InfoPtr->Index].Address3)
	SetWindowText(GetDlgItem(hWnd,IDC_CITYNAME),(*AddArray)[InfoPtr->Index].CityName)
	SetWindowText(GetDlgItem(hWnd,IDC_STATENAME),(*AddArray)[InfoPtr->Index].StateName)
	SetWindowText(GetDlgItem(hWnd,IDC_ZIPCODE),(*AddArray)[InfoPtr->Index].ZipCode)
	SetWindowText(GetDlgItem(hWnd,IDC_PHONE),(*AddArray)[InfoPtr->Index].Phone)
	SetWindowText(GetDlgItem(hWnd,IDC_FAX),(*AddArray)[InfoPtr->Index].Fax)
	SetWindowText(GetDlgItem(hWnd,IDC_EMAIL),(*AddArray)[InfoPtr->Index].Email)
	SetWindowText(GetDlgItem(hWnd,IDC_URL),(*AddArray)[InfoPtr->Index].Url)
	SetWindowText(GetDlgItem(hWnd,IDC_COMMENTS),(*AddArray)[InfoPtr->Index].Comments)
	InfoPtr->IsRecModified = SaveState
End Sub
'==============================================================================
Sub Dlg2Udt(hWnd As HWND)
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArray
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	AddArray = InfoPtr->AddArrayPtr
	
	Raw As fstring fs
	GetWindowText(GetDlgItem(hWnd,IDC_COMPANY),(*AddArray)[InfoPtr->Index].Company,Sizeof((*AddArray)[InfoPtr->Index].Company))
	GetWindowText(GetDlgItem(hWnd,IDC_LASTNAME),(*AddArray)[InfoPtr->Index].LastName,Sizeof((*AddArray)[InfoPtr->Index].LastName))
	GetWindowText(GetDlgItem(hWnd,IDC_FIRSTNAME),(*AddArray)[InfoPtr->Index].FirstName,Sizeof((*AddArray)[InfoPtr->Index].FirstName))
	GetWindowText(GetDlgItem(hWnd,IDC_ADDRESS1),(*AddArray)[InfoPtr->Index].Address1,Sizeof((*AddArray)[InfoPtr->Index].Address1))
	GetWindowText(GetDlgItem(hWnd,IDC_ADDRESS2),(*AddArray)[InfoPtr->Index].Address2,Sizeof((*AddArray)[InfoPtr->Index].Address2))
	GetWindowText(GetDlgItem(hWnd,IDC_ADDRESS3),(*AddArray)[InfoPtr->Index].Address3,Sizeof((*AddArray)[InfoPtr->Index].Address3))
	GetWindowText(GetDlgItem(hWnd,IDC_CITYNAME),(*AddArray)[InfoPtr->Index].CityName,Sizeof((*AddArray)[InfoPtr->Index].CityName))
	GetWindowText(GetDlgItem(hWnd,IDC_STATENAME),(*AddArray)[InfoPtr->Index].StateName,Sizeof((*AddArray)[InfoPtr->Index].StateName))
	GetWindowText(GetDlgItem(hWnd,IDC_ZIPCODE),(*AddArray)[InfoPtr->Index].ZipCode,Sizeof((*AddArray)[InfoPtr->Index].ZipCode))
	GetWindowText(GetDlgItem(hWnd,IDC_PHONE),(*AddArray)[InfoPtr->Index].Phone,Sizeof((*AddArray)[InfoPtr->Index].Phone))
	GetWindowText(GetDlgItem(hWnd,IDC_FAX),(*AddArray)[InfoPtr->Index].Fax,Sizeof((*AddArray)[InfoPtr->Index].Fax))
	GetWindowText(GetDlgItem(hWnd,IDC_EMAIL),(*AddArray)[InfoPtr->Index].Email,Sizeof((*AddArray)[InfoPtr->Index].Email))
	GetWindowText(GetDlgItem(hWnd,IDC_URL),(*AddArray)[InfoPtr->Index].Url,Sizeof((*AddArray)[InfoPtr->Index].Url))
	GetWindowText(GetDlgItem(hWnd,IDC_COMMENTS),(*AddArray)[InfoPtr->Index].Comments,Sizeof((*AddArray)[InfoPtr->Index].Comments))
 
End Sub
'==============================================================================
Function PrintRecord(hWnd As HWND)	
	Raw As DlgInfoType Ptr InfoPtr
	Raw As AddressTypeArray Ptr AddArray
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	AddArray = InfoPtr->AddArrayPtr

	Raw As fstring fsRec
	Raw As fstring fsBuffer
	Dim As HFONT hFont,hOldFont
	Dim As TEXTMETRIC tm
	Dim As Integer xChar,yChar,xPage,yPage,i,iLineCount,iCharsCopied
	Raw As DWORD dwBytes = 128 
	Raw As DWORD nBufferSize = 1024
	Raw As DWORD Ptr dwPtr
	Dim As DWORD dwWord
	Dim As RECT rc
	Dim As HDC hdcPrn
	Raw As DOCINFO di = {sizeof(DOCINFO),"Print1: Printing"}
	Dim As HWND hCtl
	fsBuffer.Make(0,nBufferSize)	
	
	GetDefaultPrinter(fsBuffer.lpStr(),&dwBytes)
	hdcPrn = CreateDC(NULL,fsBuffer.lpStr(),NULL,NULL)
	If hdcPrn = NULL Then
		Function = -1
	EndIf
	
	hFont = CreateFont(-1*(15*GetDeviceCaps(hdcPrn,LOGPIXELSY))/72,0,0,0,FW_HEAVY,0,TRUE,0,0,0,0,0,0,"Ariel")	
	fsRec.Make(0,32)
	GetWindowText(GetDlgItem(hWnd,IDC_INDEX),fsRec.lpStr(),fsRec.Len())
	Raw As fstring fs("Address Book, Record ")
	fs+=fsRec
	xPage = GetDeviceCaps(hdcPrn,HORZRES)
	yPage = GetDeviceCaps(hdcPrn,VERTRES)
	If StartDoc(hdcPrn,&di) > 0 Then
		If StartPage(hdcPrn) > 0 Then
			hOldFont = (HFONT)SelectObject(hdcPrn,hFont)
			GetTextMetrics(hdcPrn,&tm)
			yChar = tm.tmHeight + tm.tmExternalLeading
			xChar = tm.tmAveCharWidth
			rc.top = 200
			rc.bottom = rc.top + yChar
			rc.left = 0
			rc.right = xPage 
			DrawText(hdcPrn,fs.lpStr(),-1,&rc,DT_CENTER)
			DeleteObject(SelectObject(hdcPrn,hOldFont))
			hFont = CreateFont(-1*(11*GetDeviceCaps(hdcPrn,LOGPIXELSY))/72,0,0,0,FW_HEAVY,0,0,0,0,0,0,0,0,"Ariel")
			hOldFont = (HFONT)SelectObject(hdcPrn,hFont)
			GetTextMetrics(hdcPrn,&tm)
			yChar = tm.tmHeight + tm.tmExternalLeading + 20
			xChar = tm.tmAveCharWidth
			TextOut(hdcPrn,300,600,"Company:",8)
			TextOut(hdcPrn,300,600+1*yChar,"Name:",5)
			TextOut(hdcPrn,300,600+3*yChar,"Address:",8)
			TextOut(hdcPrn,300,600+4*yChar,"City:",5)
			TextOut(hdcPrn,300,600+5*yChar,"State/Prov:",11)
			TextOut(hdcPrn,300,600+6*yChar,"Zip/Postal:",11)
			TextOut(hdcPrn,300,600+7*yChar,"Country:",8)
			TextOut(hdcPrn,300,600+9*yChar,"Phone:",6)
			TextOut(hdcPrn,300,600+10*yChar,"Fax:",4)
			TextOut(hdcPrn,300,600+11*yChar,"Email:",6)
			TextOut(hdcPrn,300,600+12*yChar,"Url:",4)
			TextOut(hdcPrn,300,600+14*yChar,"Comments:",9)
			DeleteObject(SelectObject(hdcPrn,hOldFont))
			fsBuffer = (*AddArray)[InfoPtr->Index].Company
			TextOut(hdcPrn,1000,600,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].FirstName 
			fsBuffer+= " "
			fsBuffer+= (*AddArray)[InfoPtr->Index].LastName
			TextOut(hdcPrn,1000,600+1*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].Address1
			TextOut(hdcPrn,1000,600+3*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].CityName
			TextOut(hdcPrn,1000,600+4*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].StateName
			TextOut(hdcPrn,1000,600+5*yChar,fsBuffer.lpStr(),fsBuffer.Len())

			fsBuffer = (*AddArray)[InfoPtr->Index].ZipCode
			TextOut(hdcPrn,1000,600+6*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer.Make(0,128)
			hCtl = GetDlgItem(hWnd,IDC_COUNTRY)
			GetWindowText(hCtl,fsBuffer.lpStr(),128)
			TextOut(hdcPrn,1000,600+7*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].Phone
			TextOut(hdcPrn,1000,600+9*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].Fax
			TextOut(hdcPrn,1000,600+10*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].Email
			TextOut(hdcPrn,1000,600+11*yChar,fsBuffer.lpStr(),fsBuffer.Len())
			
			fsBuffer = (*AddArray)[InfoPtr->Index].Url
			TextOut(hdcPrn,1000,600+12*yChar,fsBuffer.lpStr(),fsBuffer.Len())

			hCtl = GetDlgItem(hWnd,IDC_COMMENTS)
			iLineCount = SendMessage(hCtl,EM_GETLINECOUNT,0,0)
			fsBuffer.Make(0,1024)
			dwPtr = (DWORD*)fsBuffer.lpStr()
			For i = 0 To iLineCount -1
				*dwPtr = MAKELONG(1024,0)
				iCharsCopied = SendMessage(hCtl,EM_GETLINE,i,fsBuffer.lpStr())
				TextOut(hdcPrn,1000,600+(15+i)*yChar,fsBuffer.lpStr(),iCharsCopied)
			Next
			If EndPage(hdcPrn) > 0 Then
				EndDoc(hdcPrn)
			EndIf
		End If
	EndIf
	DeleteDC(hdcPrn)
	Function = 0 
End Function
'==============================================================================
Sub SetButtonStatus(hWnd As HWND)
	Dim As DlgInfoType Ptr InfoPtr
	InfoPtr = (DlgInfoType*)GetProp(hWnd,"DLGINFO")
	If InfoPtr->IsRecModified Then
		EnableWindow(CTLHNDL(IDC_ADD),TRUE)
		EnableWindow(CTLHNDL(IDC_UPDATE),TRUE)
	Else
		EnableWindow(CTLHNDL(IDC_ADD),FALSE)
		EnableWindow(CTLHNDL(IDC_UPDATE),FALSE)
	EndIf
End Sub
'==============================================================================
